//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.AnyTypeTest
{
    
    
    /// <summary>
    /// A class that exposes the IAnyTypeTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class AnyTypeTestProvider : IFeatureProvider
    {
        
        private IAnyTypeTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(AnyTypeTestProvider).Assembly, "AnyTypeTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public AnyTypeTestProvider(IAnyTypeTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<SetAnyTypeValueRequestDto, SetAnyTypeValueResponseDto>("SetAnyTypeValue", SetAnyTypeValue);
            registration.RegisterUnobservableProperty("AnyTypeStringValue", GetAnyTypeStringValue);
            registration.RegisterUnobservableProperty("AnyTypeIntegerValue", GetAnyTypeIntegerValue);
            registration.RegisterUnobservableProperty("AnyTypeRealValue", GetAnyTypeRealValue);
            registration.RegisterUnobservableProperty("AnyTypeBooleanValue", GetAnyTypeBooleanValue);
            registration.RegisterUnobservableProperty("AnyTypeBinaryValue", GetAnyTypeBinaryValue);
            registration.RegisterUnobservableProperty("AnyTypeDateValue", GetAnyTypeDateValue);
            registration.RegisterUnobservableProperty("AnyTypeTimeValue", GetAnyTypeTimeValue);
            registration.RegisterUnobservableProperty("AnyTypeTimestampValue", GetAnyTypeTimestampValue);
            registration.RegisterUnobservableProperty("AnyTypeListValue", GetAnyTypeListValue);
            registration.RegisterUnobservableProperty("AnyTypeStructureValue", GetAnyTypeStructureValue);
        }
        
        /// <summary>
        /// Executes the Set Any Type Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual SetAnyTypeValueResponseDto SetAnyTypeValue(SetAnyTypeValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new SetAnyTypeValueResponseDto(_implementation.SetAnyTypeValue(request.AnyTypeValue.TryExtract(_server, "org.silastandard/test/AnyTypeTest/v1/Command/SetAnyTypeValue/Parameter/AnyTypeVal" +
                                "ue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "anyTypeValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/AnyTypeTest/v1/Command/SetAnyTypeValue/Parameter/AnyTypeVal" +
                            "ue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Any Type String Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeStringValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeStringValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type Integer Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeIntegerValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeIntegerValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type Real Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeRealValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeRealValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type Boolean Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeBooleanValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeBooleanValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type Binary Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeBinaryValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeBinaryValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type Date Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeDateValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeDateValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type Time Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeTimeValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeTimeValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type Timestamp Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeTimestampValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeTimestampValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type List Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeListValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeListValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Any Type Structure Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto> GetAnyTypeStructureValue()
        {
            return new PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>(new Tecan.Sila2.DynamicClient.AnyTypeDto(_implementation.AnyTypeStructureValue, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/AnyTypeTest/v1/Command/SetAnyTypeValue"))
            {
                return typeof(IAnyTypeTest).GetMethod("SetAnyTypeValue");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeStringValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeStringValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeIntegerValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeIntegerValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeRealValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeRealValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeBooleanValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeBooleanValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeBinaryValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeBinaryValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeDateValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeDateValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeTimeValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeTimeValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeTimestampValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeTimestampValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeListValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeListValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeStructureValue"))
            {
                return typeof(IAnyTypeTest).GetProperty("AnyTypeStructureValue");
            }
            return null;
        }
    }
}

